<template>
  <div class="page">
    <app-menu
      title="New snippet">
    </app-menu>
    <div class="SaveSnippetContent">
      <div class="_top">
        <el-autocomplete
          ref="snippetName"
          v-model="snippetName"
          :clearable="true"
          class="_name"
          @keyup.ctrl.enter.native="saveSnippet"
          value-key="name"
          :fetch-suggestions="snippetsSearch"
          placeholder="Snippet name"
          :trigger-on-focus="false"/>
        <el-input
          class="_trigger"
          @focus="isTabTriggerFocused = true"
          v-model="tabTrigger"
          placeholder="Tab trigger"/>
      </div>
      <div class="_cmWrapper">
        <div class="_selectMode">
          <el-select
            size="mini"
            v-model="cmOptions.mode">
            <el-option
              v-for="item in modeOptions"
              :key="item.value"
              :label="item.label"
              :value="item.value">
            </el-option>
          </el-select>
        </div>
        <client-only>
          <codemirror
            class="cmEditor"
            ref="cmEditor"
            :options="cmOptions"
            @input="onCmCodeChange"
            :value="code" />
        </client-only>
      </div>
      <el-button
        :disabled="isSaveDisabled"
        @click="saveSnippet"
        type="primary">
        Save
      </el-button>
    </div>
  </div>
</template>

<script>
export default {
  async asyncData({ $axios, error }) {
    const { data: snippets } = await $axios.get('/snippets/get')
    return $axios.get('/snippets/saving-snippet-data')
      .then((res) => {
        return {
          snippetData: res.data.snippetData,
          snippetName: res.data.snippetName || '',
          tabTrigger: res.data.snippetName || '',
          snippets,
        }
      })
      .catch((e) => {
        error({ statusCode: 404, message: 'Snippet data not found' })
      })
  },
  data() {
    return {
      isTabTriggerFocused: false,
      code: '',
      cmOptions: {
        mode: 'text/javascript',
        tabSize: 2,
      },
      modeOptions: [
        { value: 'text/javascript', label: 'Javascript' },
        { value: 'text/x-vue', label: 'Vue' },
        { value: 'text/css', label: 'Css' },
        { value: 'text/x-less', label: 'Less' },
        { value: 'text/x-scss', label: 'Scss' },
        { value: 'text/x-gfm', label: 'Markdown' },
        { value: 'text/html', label: 'Html' },
        { value: 'text/x-pug', label: 'Pug' },
        { value: 'text/x-php', label: 'Php' },
        { value: 'text/x-python', label: 'Python' },
        { value: 'text/x-java', label: 'Java' },
        { value: 'text/x-dart', label: 'Dart' },
      ],
    }
  },
  computed: {
    isSaveDisabled() {
      return !this.snippetName
    }
  },
  watch: {
    snippetName(val) {
      if (!this.isTabTriggerFocused) {
        this.tabTrigger = val
      }
      if (!val) {
        this.isTabTriggerFocused = false
        this.tabTrigger = ''
      }
    },
  },
  mounted() {
    this.code = this.removeExtraSpace(this.snippetData)
    if (process.client) {
      this.$refs.snippetName.focus()
    }
  },
  methods: {
    snippetsSearch(queryString, cb) {
      const results = queryString
        ? fuzzysort.go(queryString, this.snippets, { keys: ['name'] }).map(item => item.obj)
        : this.snippets
      cb(results)
    },
    onCmCodeChange(newCode) {
      this.code = newCode
    },
    async saveSnippet() {
      try {
        const code = `<snippet>\n  <content><![CDATA[\n${this.code}\n]]></content>\n  <tabTrigger>${this.tabTrigger}</tabTrigger>\n</snippet>`
        await this.$axios.post('/snippets/create', {
          name: this.snippetName,
          code
        })
        this.$message({
          message: 'Snippet saved',
          type: 'success'
        })
      } catch (e) {
        console.log(e)
        this.$message.error(e)
      }
    },
    removeExtraSpace(inputCode) {
      try {
        const codeSplit = inputCode.split('\n')
        const firstLineSplit = codeSplit[0].split(/\S/)
        const resArr = codeSplit.map((item) => {
          const itemSplit = item.split('')
          for (let i = 0; i < firstLineSplit[0].length; i++) {
            if (itemSplit[0] !== undefined) {
              if (itemSplit[0].trim() === '') {
                itemSplit.splice(0, 1)
              }
            }
          }
          return itemSplit.join('')
        })
        return resArr.join('\n')
      } catch (e) {
        return inputCode
      }
    }
  },
}
</script>

<style lang="less">
.SaveSnippetContent {
  box-sizing: border-box;
  display: flex;
  flex-direction: column;
  ._top {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
  }
  ._name {
    width: 100%;
  }
  ._trigger {
    width: 100%;
  }
  ._cmWrapper {
    position: relative;
  }
  ._selectMode {
    position: absolute;
    bottom: 0;
    right: 18px;
    z-index: 10;
  }
}

.cmEditor {
  height: 100%;
  .CodeMirror {
    height: calc(~"100vh - 120px");
  }
}

</style>